gtkmm: Gtk::Label Class Reference

gtkmm 3.24.8

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::Label Class Reference
Widgets

A widget that displays a small to medium amount of text. More...

`#include <gtkmm/label.h>`

Inheritance diagram for Gtk::Label:
[legend]

## Public Member Functions
| Label (Label && src) noexcept
Label & | operator= (Label && src) noexcept
| Label (const Label &)=delete
Label & | operator= (const Label &)=delete
| ~Label () noexcept override
GtkLabel * | gobj ()
| Provides access to the underlying C GObject.
const GtkLabel * | gobj () const
| Provides access to the underlying C GObject.
| Label ()
| Label (const Glib::ustring & label, bool mnemonic=false)
| Label (const Glib::ustring & label, float xalign, float yalign, bool mnemonic=false)
| This constructor is a shortcut for often used code when you want to create a label with alignment different than default one.
| Label (const Glib::ustring & label, Align halign, Align valign=ALIGN_CENTER, bool mnemonic=false)
| This constructor is a shortcut to create a Label with Widget alignment properties different from the default ALIGN_FILL.
void | set_text (const Glib::ustring & str)
| Doesn't use markup.
Glib::ustring | get_text () const
| Fetches the text from a label widget, as displayed on the screen.
void | set_attributes (Pango::AttrList & attrs)
| Sets a Pango::AttrList; the attributes in the list are applied to the label text.
Pango::AttrList | get_attributes () const
| Gets the attribute list that was set on the label using set_attributes(), if any.
void | set_label (const Glib::ustring & str)
| Sets the text of the label.
Glib::ustring | get_label () const
| Fetches the text from a label widget including any embedded underlines indicating mnemonics and Pango markup.
void | set_markup (const Glib::ustring & str)
| Parses str which is marked up with the [Pango text markup language][PangoMarkupFormat], setting the label’s text and attribute list based on the parse results.
void | set_use_markup (bool setting=true)
| Sets whether the text of the label contains markup in [Pango’s text markup language][PangoMarkupFormat].
bool | get_use_markup () const
| Returns whether the label’s text is interpreted as marked up with the [Pango text markup language][PangoMarkupFormat].
void | set_use_underline (bool setting=true)
| If true, an underline in the text indicates the next character should be used for the mnemonic accelerator key.
bool | get_use_underline () const
| Returns whether an embedded underline in the label indicates a mnemonic.
void | set_markup_with_mnemonic (const Glib::ustring & str)
| Parses str which is marked up with the [Pango text markup language][PangoMarkupFormat], setting the label’s text and attribute list based on the parse results.
guint | get_mnemonic_keyval () const
| If the label has been set so that it has an mnemonic key this function returns the keyval used for the mnemonic accelerator.
void | set_mnemonic_widget (Widget & widget)
| If the label has been set so that it has an mnemonic key (using i.e. set_markup_with_mnemonic(), set_text_with_mnemonic(), new_with_mnemonic() or the “use_underline” property) the label can be associated with a widget that is the target of the mnemonic.
Widget * | get_mnemonic_widget ()
| Retrieves the target of the mnemonic (keyboard shortcut) of this label.
const Widget * | get_mnemonic_widget () const
| Retrieves the target of the mnemonic (keyboard shortcut) of this label.
void | set_text_with_mnemonic (const Glib::ustring & str)
| Sets the label’s text from the string str.
void | set_justify (Justification jtype)
| Sets the alignment of the lines in the text of the label relative to each other.
Justification | get_justify () const
| Returns the justification of the label.
void | set_ellipsize (Pango::EllipsizeMode mode)
| Sets the mode used to ellipsize (add an ellipsis: "...") to the text if there is not enough space to render the entire string.
Pango::EllipsizeMode | get_ellipsize () const
| Returns the ellipsizing position of the label.
void | set_width_chars (int n_chars)
| Sets the desired width in characters of label to n_chars.
int | get_width_chars () const
| Retrieves the desired width of label, in characters.
void | set_max_width_chars (int n_chars)
| Sets the desired maximum width in characters of label to n_chars.
int | get_max_width_chars () const
| Retrieves the desired maximum width of label, in characters.
void | set_lines (int lines)
| Sets the number of lines to which an ellipsized, wrapping label should be limited.
int | get_lines () const
| Gets the number of lines to which an ellipsized, wrapping label should be limited.
void | set_pattern (const Glib::ustring & pattern)
| The pattern of underlines you want under the existing text within the Gtk::Label widget.
void | set_line_wrap (bool wrap=true)
| Toggles line wrapping within the Gtk::Label widget.
bool | get_line_wrap () const
| Returns whether lines in the label are automatically wrapped.
void | set_line_wrap_mode (Pango::WrapMode wrap_mode)
| If line wrapping is on (see set_line_wrap()) this controls how the line wrapping is done.
Pango::WrapMode | get_line_wrap_mode () const
| Returns line wrap mode used by the label.
void | set_selectable (bool setting=true)
| Selectable labels allow the user to select text from the label, for copy-and-paste.
bool | get_selectable () const
| Gets the value set by set_selectable().
void | set_angle (double angle)
| Sets the angle of rotation for the label.
double | get_angle () const
| Gets the angle of rotation for the label.
void | select_region (int start_offset, int end_offset)
| Selects a range of characters in the label, if the label is selectable.
void | select_region (int start_offset)
| Selects a range of characters in the label, from start_offset to the end, if the label is selectable.
bool | get_selection_bounds (int &start, int &end) const
| Gets the selected range of characters in the label, returning `true` if there’s a selection.
Glib::RefPtr< Pango::Layout > | get_layout ()
| Gets the Pango::Layout used to display the label.
Glib::RefPtr< const Pango::Layout > | get_layout () const
| Gets the Pango::Layout used to display the label.
void | get_layout_offsets (int & x, int & y) const
| Obtains the coordinates where the label will draw the Pango::Layout representing the text in the label; useful to convert mouse events into coordinates inside the Pango::Layout, e.g. to take some action if some part of the label is clicked.
void | set_single_line_mode (bool single_line_mode=true)
| Sets whether the label is in single line mode.
bool | get_single_line_mode () const
| Returns whether the label is in single line mode.
Glib::ustring | get_current_uri () const
| Returns the URI for the currently active link in the label.
void | set_track_visited_links (bool track_links=true)
| Sets whether the label should keep track of clicked links (and use a different color for them).
bool | get_track_visited_links () const
| Returns whether the label is currently keeping track of clicked links.
void | set_xalign (float xalign)
| Sets the Gtk::Label::property_xalign() property for label.
float | get_xalign () const
| Gets the Gtk::Label::property_xalign() property for label.
void | set_yalign (float yalign)
| Sets the Gtk::Label::property_yalign() property for label.
float | get_yalign () const
| Gets the Gtk::Label::property_yalign() property for label.
Glib::SignalProxy< void, Menu * > | signal_populate_popup ()
Glib::SignalProxy< bool, const Glib::ustring & > | signal_activate_link ()
Glib::PropertyProxy< Glib::ustring > | property_label ()
| The contents of the label.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_label () const
| The contents of the label.
Glib::PropertyProxy< Pango::AttrList > | property_attributes ()
| A list of style attributes to apply to the text of the label.
Glib::PropertyProxy_ReadOnly< Pango::AttrList > | property_attributes () const
| A list of style attributes to apply to the text of the label.
Glib::PropertyProxy< bool > | property_use_markup ()
| The text of the label includes XML markup.
Glib::PropertyProxy_ReadOnly< bool > | property_use_markup () const
| The text of the label includes XML markup.
Glib::PropertyProxy< bool > | property_use_underline ()
| If set, an underline in the text indicates the next character should be used for the mnemonic accelerator key.
Glib::PropertyProxy_ReadOnly< bool > | property_use_underline () const
| If set, an underline in the text indicates the next character should be used for the mnemonic accelerator key.
Glib::PropertyProxy< Justification > | property_justify ()
| The alignment of the lines in the text of the label relative to each other.
Glib::PropertyProxy_ReadOnly< Justification > | property_justify () const
| The alignment of the lines in the text of the label relative to each other.
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_pattern ()
| A string with _ characters in positions correspond to characters in the text to underline.
Glib::PropertyProxy< bool > | property_wrap ()
| If set, wrap lines if the text becomes too wide.
Glib::PropertyProxy_ReadOnly< bool > | property_wrap () const
| If set, wrap lines if the text becomes too wide.
Glib::PropertyProxy< Pango::WrapMode > | property_wrap_mode ()
| If line wrapping is on (see the Gtk::Label::property_wrap() property) this controls how the line wrapping is done.
Glib::PropertyProxy_ReadOnly< Pango::WrapMode > | property_wrap_mode () const
| If line wrapping is on (see the Gtk::Label::property_wrap() property) this controls how the line wrapping is done.
Glib::PropertyProxy< bool > | property_selectable ()
| Whether the label text can be selected with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_selectable () const
| Whether the label text can be selected with the mouse.
Glib::PropertyProxy_ReadOnly< guint > | property_mnemonic_keyval () const
| The mnemonic accelerator key for this label.
Glib::PropertyProxy< Widget * > | property_mnemonic_widget ()
| The widget to be activated when the label's mnemonic key is pressed.
Glib::PropertyProxy_ReadOnly< Widget * > | property_mnemonic_widget () const
| The widget to be activated when the label's mnemonic key is pressed.
Glib::PropertyProxy_ReadOnly< int > | property_cursor_position () const
| The current position of the insertion cursor in chars.
Glib::PropertyProxy_ReadOnly< int > | property_selection_bound () const
| The position of the opposite end of the selection from the cursor in chars.
Glib::PropertyProxy< Pango::EllipsizeMode > | property_ellipsize ()
| The preferred place to ellipsize the string, if the label does not have enough room to display the entire string, specified as a Pango::EllipsizeMode.
Glib::PropertyProxy_ReadOnly< Pango::EllipsizeMode > | property_ellipsize () const
| The preferred place to ellipsize the string, if the label does not have enough room to display the entire string, specified as a Pango::EllipsizeMode.
Glib::PropertyProxy< int > | property_width_chars ()
| The desired width of the label, in characters.
Glib::PropertyProxy_ReadOnly< int > | property_width_chars () const
| The desired width of the label, in characters.
Glib::PropertyProxy< bool > | property_single_line_mode ()
| Whether the label is in single line mode.
Glib::PropertyProxy_ReadOnly< bool > | property_single_line_mode () const
| Whether the label is in single line mode.
Glib::PropertyProxy< double > | property_angle ()
| The angle that the baseline of the label makes with the horizontal, in degrees, measured counterclockwise.
Glib::PropertyProxy_ReadOnly< double > | property_angle () const
| The angle that the baseline of the label makes with the horizontal, in degrees, measured counterclockwise.
Glib::PropertyProxy< int > | property_max_width_chars ()
| The desired maximum width of the label, in characters.
Glib::PropertyProxy_ReadOnly< int > | property_max_width_chars () const
| The desired maximum width of the label, in characters.
Glib::PropertyProxy< bool > | property_track_visited_links ()
| Set this property to `true` to make the label track which links have been visited.
Glib::PropertyProxy_ReadOnly< bool > | property_track_visited_links () const
| Set this property to `true` to make the label track which links have been visited.
Glib::PropertyProxy< int > | property_lines ()
| The number of lines to which an ellipsized, wrapping label should be limited.
Glib::PropertyProxy_ReadOnly< int > | property_lines () const
| The number of lines to which an ellipsized, wrapping label should be limited.
Glib::PropertyProxy< float > | property_xalign ()
| The xalign property determines the horizontal aligment of the label text inside the labels size allocation.
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| The xalign property determines the horizontal aligment of the label text inside the labels size allocation.
Glib::PropertyProxy< float > | property_yalign ()
| The yalign property determines the vertical aligment of the label text inside the labels size allocation.
Glib::PropertyProxy_ReadOnly< float > | property_yalign () const
| The yalign property determines the vertical aligment of the label text inside the labels size allocation.
Public Member Functions inherited from Gtk::Misc
| Misc (Misc && src) noexcept
Misc & | operator= (Misc && src) noexcept
| Misc (const Misc &)=delete
Misc & | operator= (const Misc &)=delete
| ~Misc () noexcept override
GtkMisc * | gobj ()
| Provides access to the underlying C GObject.
const GtkMisc * | gobj () const
| Provides access to the underlying C GObject.
void | set_alignment (float xalign=0.0, float yalign=0.5)
| Sets the alignment of the widget.
void | set_alignment (Align xalign=Gtk::ALIGN_START, Align yalign=Gtk::ALIGN_CENTER)
| Sets the alignment of the widget.
void | get_alignment (float & xalign, float & yalign) const
| Gets the X and Y alignment of the widget within its allocation.
void | set_padding (int xpad, int ypad)
| Sets the amount of space to add around the widget.
void | get_padding (int & xpad, int & ypad) const
| Gets the padding in the X and Y directions of the widget.
Glib::PropertyProxy< float > | property_xalign ()
| The horizontal alignment.
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| The horizontal alignment.
Glib::PropertyProxy< float > | property_yalign ()
| The vertical alignment.
Glib::PropertyProxy_ReadOnly< float > | property_yalign () const
| The vertical alignment.
Glib::PropertyProxy< int > | property_xpad ()
| The amount of space to add on the left and right of the widget, in pixels.
Glib::PropertyProxy_ReadOnly< int > | property_xpad () const
| The amount of space to add on the left and right of the widget, in pixels.
Glib::PropertyProxy< int > | property_ypad ()
| The amount of space to add on the top and bottom of the widget, in pixels.
Glib::PropertyProxy_ReadOnly< int > | property_ypad () const
| The amount of space to add on the top and bottom of the widget, in pixels.
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
void | show ()
| Flags a widget to be displayed.
void | show_now ()
| Shows a widget.
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user).
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container).
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget.
void | queue_draw_area (int x, int y, int width, int height)
| Convenience function that calls queue_draw_region() on the region created from the given coordinates.
void | queue_draw_region (const ::Cairo::RefPtr< const ::Cairo::Region > & region)
| Invalidates the area of widget defined by region by calling gdk_window_invalidate_region() on the widget’s window and all its child windows.
void | queue_resize ()
| This function is only for use in widget implementations.
void | queue_allocate ()
| This function is only for use in widget implementations.
void | size_allocate (const Allocation & allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets.
void | size_allocate (const Allocation & allocation, int baseline)
| This function is only used by Gtk::Container subclasses, to assign a size, position and (optionally) baseline to their child widgets.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | get_preferred_width (int & minimum_width, int & natural_width) const
| Retrieves a widget’s initial minimum and natural width.
void | get_preferred_height_for_width (int width, int & minimum_height, int & natural_height) const
| Retrieves a widget’s minimum and natural height if it would be given the specified width.
void | get_preferred_height_for_width (int width, int & minimum_height, int & natural_height, int & minimum_baseline, int & natural_baseline) const
| Retrieves a widget’s minimum and natural height and the corresponding baselines if it would be given the specified width, or the default height if width is -1.
void | get_preferred_height (int & minimum_height, int & natural_height) const
| Retrieves a widget’s initial minimum and natural height.
void | get_preferred_width_for_height (int height, int & minimum_width, int & natural_width) const
| Retrieves a widget’s minimum and natural width if it would be given the specified height.
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
void | add_accelerator (const Glib::ustring & accel_signal, const Glib::RefPtr< AccelGroup > & accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated.
bool | remove_accelerator (const Glib::RefPtr< AccelGroup > & accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator().
void | set_accel_path (const Glib::ustring & accel_path, const Glib::RefPtr< AccelGroup > & accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated.
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal.
bool | event (GdkEvent * gdk_event)
| Rarely-used function.
int | send_expose (GdkEvent * gdk_event)
| Very rarely-used function.
bool | send_focus_change (GdkEvent * gdk_event)
| Sends the focus change gdk_event to widget.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | reparent (Widget & new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget.
bool | intersect (const Gdk::Rectangle & area) const
bool | intersect (const Gdk::Rectangle & area, Gdk::Rectangle & intersection) const
| Computes the intersection of a widget’s area and area, storing the intersection in intersection, and returns `true` if there was an intersection.
::Cairo::RefPtr< ::Cairo::Region > | region_intersect (const ::Cairo::RefPtr< ::Cairo::Region > & region) const
| Computes the intersection of a widget’s area and region, returning the intersection.
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget.
void | child_notify (const Glib::ustring & child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the [child property][child-properties] child_property on widget.
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify().
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus.
bool | get_can_focus () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget.
bool | get_can_default () const
| Determines whether widget can be a default widget.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | grab_default ()
| Causes widget to become the default widget.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse).
bool | device_is_shadowed (const Glib::RefPtr< const Gdk::Device > & device)
| Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget.
void | add_modal_grab ()
| Block events to everything else than this widget and its children.
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed.
void | set_name (const Glib::ustring & name)
| Widgets can be named, which allows you to refer to them from a CSS file.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state (StateType state)
| This function is for use in widget implementations.
StateType | get_state () const
| Returns the widget’s state.
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations.
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity (in the sense of returning the value that has been set using set_sensitive()).
bool | is_sensitive () const
| Returns the widget’s effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own.
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget.
bool | get_is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering.
bool | get_double_buffered () const
| Determines whether the widget is double buffered.
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes.
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show().
bool | get_child_visible () const
| Gets the value set with set_child_visible().
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget’s window if it is realized, `nullptr` otherwise.
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget’s window if it is realized, `nullptr` otherwise.
void | register_window (const Glib::RefPtr< Gdk::Window > & window)
| Registers a Gdk::Window with the widget and sets it up so that the widget receives events for it.
void | unregister_window (const Glib::RefPtr< Gdk::Window > & window)
| Unregisters a Gdk::Window from the widget that was previously set up with register_window().
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget.
void | get_allocated_size (Allocation & allocation, int & baseline) const
| Retrieves the widget’s allocated size.
Allocation | get_allocation () const
| Retrieves the widget's location.
void | set_allocation (const Allocation & allocation)
| Sets the widget’s allocation.
void | set_clip (const Allocation & clip)
| Sets the widget’s clip.
Allocation | get_clip () const
| Retrieves the widget’s clip area.
Container * | get_parent ()
| Returns the parent container of widget.
const Container * | get_parent () const
| Returns the parent container of widget.
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget’s parent window, or `nullptr` if it does not have one.
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget’s parent window, or `nullptr` if it does not have one.
void | set_parent_window (const Glib::RefPtr< const Gdk::Window > & parent_window)
| Sets a non default parent window for widget.
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you’d use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order.
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget’s size request will be at least width by height.
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget.
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget.
void | set_device_events (const Glib::RefPtr< const Gdk::Device > & device, Gdk::EventMask events)
| Sets the device event mask (see Gdk::EventMask) for a widget.
void | add_device_events (const Glib::RefPtr< const Gdk::Device > & device, Gdk::EventMask events)
| Adds the device events in the bitfield events to the event mask for widget.
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent, with opacity 0 being fully transparent and 1 fully opaque.
double | get_opacity () const
| Fetches the requested opacity for this widget.
void | set_device_enabled (const Glib::RefPtr< Gdk::Device > & device, bool enabled=true)
| Enables or disables a Gdk::Device to interact with widget and all its children.
bool | get_device_enabled (const Glib::RefPtr< const Gdk::Device > & device) const
| Returns whether device can interact with widget and its children.
Container * | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of.
const Container * | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget.
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget.
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located.
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring & selection)
| Returns the clipboard object for the given selection to be used with widget.
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring & selection) const
| Returns the clipboard object for the given selection to be used with widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used.
void | queue_compute_expand ()
| Mark widget as needing to recompute its expand flags.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
bool | get_support_multidevice () const
| Returns `true` if widget is multiple pointer aware.
void | set_support_multidevice (bool support_multidevice=true)
| Enables or disables multiple pointer awareness.
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology.
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology.
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property.
Align | get_valign_with_baseline () const
| Gets the value of the Gtk::Widget::property_valign() property, including Gtk::ALIGN_BASELINE.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_left () const
| Gets the value of the Gtk::Widget::property_margin_left() property.
void | set_margin_left (int margin)
| Sets the left margin of widget.
int | get_margin_right () const
| Gets the value of the Gtk::Widget::property_margin_right() property.
void | set_margin_right (int margin)
| Sets the right margin of widget.
int | get_margin_start () const
| Gets the value of the Gtk::Widget::property_margin_start() property.
void | set_margin_start (int margin)
| Sets the start margin of widget.
int | get_margin_end () const
| Gets the value of the Gtk::Widget::property_margin_end() property.
void | set_margin_end (int margin)
| Sets the end margin of widget.
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
Gdk::EventMask | get_events () const
| Returns the event mask (see Gdk::EventMask) for the widget.
Gdk::EventMask | get_device_events (const Glib::RefPtr< const Gdk::Device > & device) const
| Returns the events mask for the widget corresponding to an specific device.
void | get_pointer (int & x, int & y) const
| Obtains the location of the mouse pointer in widget coordinates.
bool | is_ancestor (Widget & ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget & dest_widget, int src_x, int src_y, int & dest_x, int & dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
void | override_color (const Gdk::RGBA & color, StateFlags state=STATE_FLAG_NORMAL)
| Sets the color to use for a widget.
void | unset_color (StateFlags state=STATE_FLAG_NORMAL)
| Undoes the effect of previous calls to override_color().
void | override_background_color (const Gdk::RGBA & color, StateFlags state=STATE_FLAG_NORMAL)
| Sets the background color to use for a widget.
void | unset_background_color (StateFlags state=STATE_FLAG_NORMAL)
| Undoes the effect of previous calls to override_background_color().
void | override_font (const Pango::FontDescription & font_desc)
| Sets the font to use for a widget.
void | unset_font ()
| Undoes the effect of previous calls to override_font().
void | override_symbolic_color (const Glib::ustring & name, const Gdk::RGBA & color)
| Sets a symbolic color for a widget.
void | unset_symbolic_color (const Glib::ustring & name)
| Undoes the effect of previous calls to override_symbolic_color().
void | override_cursor (const Gdk::RGBA & cursor, const Gdk::RGBA & secondary_cursor)
| Sets the cursor color to use in a widget, overriding the cursor-color and secondary-cursor-color style properties.
void | unset_cursor ()
| Undoes the effect of previous calls to override_cursor().
void | reset_style ()
| Updates the style context of widget and all descendants by updating its widget path.
template<class PropertyType >
void | get_style_property (const Glib::ustring & the_property_name, PropertyType & value) const
| Gets the value of a style property of widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font options, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget.
void | set_font_options (const ::Cairo::FontOptions & options)
| Sets the #cairo_font_options_t used for Pango rendering in this widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
::Cairo::FontOptions | get_font_options () const
| Returns the #cairo_font_options_t used for Pango rendering.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Gdk::Pixbuf > | render_icon_pixbuf (const StockID & stock_id, IconSize size)
| A convenience function that uses the theme engine and style settings for widget to look up stock_id and render it to a pixbuf.
void | set_composite_name (const Glib::ustring & name)
| Sets a widgets composite name.
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region > & region)
| Sets a shape for this widget’s GDK window.
void | input_shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region > & region)
| Sets an input shape for this widget’s GDK window.
WidgetPath | get_path () const
| Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget.
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext > & context, const Glib::ustring & target, guint32 time)
void | drag_highlight ()
void | drag_unhighlight ()
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const std::vector< TargetEntry > & targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window > & proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
| Sets this widget as a proxy for drops to another window.
void | drag_dest_unset ()
| Clears information about a drop destination set with gtk_drag_dest_set().
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext > & context, const Glib::RefPtr< TargetList > & target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning GDK_NONE.
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext > & context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop.
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop.
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList > & target_list)
| Sets the target types that this widget can accept from drag-and-drop.
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::SelectionData to the target list of the drag destination.
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::SelectionData to the target list of the drag destination.
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::SelectionData to the target list of the drag destination.
void | drag_source_set (const std::vector< TargetEntry > & targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
| Undoes the effects of gtk_drag_source_set().
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf > & pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf.
void | drag_source_set_icon (const StockID & stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon.
void | drag_source_set_icon (const Glib::ustring & icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon.
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::SelectionData to the target list of the drag source.
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::SelectionData to the target list of the drag source.
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::SelectionData to the target list of the drag source.
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList > & targets, Gdk::DragAction actions, int button, GdkEvent * gdk_event)
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList > & targets, Gdk::DragAction actions, int button, GdkEvent * gdk_event, int x, int y)
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext > & context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
bool | get_no_show_all () const
| Returns the current value of the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_parent (Widget & parent)
| This function is useful only when implementing subclasses of Gtk::Container.
void | unparent ()
| This function is only for use in widget implementations.
void | map ()
| This function is only for use in widget implementations.
void | unmap ()
| This function is only for use in widget implementations.
void | draw_insertion_cursor (const ::Cairo::RefPtr< ::Cairo::Context > & cr, const Gdk::Rectangle & location, bool is_primary, TextDirection direction, bool draw_arrow=true)
| Draws a text caret on cr at location.
void | set_tooltip_window (Window & custom_window)
| Replaces the default window used for displaying tooltips with custom_window.
Window * | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring & text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< Gtk::StyleContext > | get_style_context () const
| Returns the style context associated to widget.
Gdk::ModifierType | get_modifier_mask (Gdk::ModifierIntent intent)
| Returns the modifier mask the widget’s windowing system backend uses for a particular purpose.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts group into widget.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
Glib::RefPtr< Gio::ActionGroup > | get_action_group (const Glib::ustring & prefix)
| Retrieves the Gio::ActionGroup that was registered using prefix.
Glib::RefPtr< const Gio::ActionGroup > | get_action_group (const Glib::ustring & prefix) const
| Retrieves the Gio::ActionGroup that was registered using prefix.
std::vector< Glib::ustring > | list_action_prefixes () const
| Retrieves a `nullptr`-terminated array of strings containing the prefixes of Gio::ActionGroup's available to widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for Pango rendering.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map that has been set with set_font_map().
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map that has been set with set_font_map().
Glib::SignalProxy< void > | signal_show ()
Glib::SignalProxy< void > | signal_hide ()
Glib::SignalProxy< void > | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void > | signal_unmap ()
Glib::SignalProxy< void > | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void > | signal_unrealize ()
Glib::SignalProxy< void, Allocation & > | signal_size_allocate ()
Glib::SignalProxy< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy< void, Gtk::StateFlags > | signal_state_flags_changed ()
Glib::SignalProxy< void, Widget * > | signal_parent_changed ()
| Informs objects that their parent changed.
Glib::SignalProxy< void, Widget * > | signal_hierarchy_changed ()
Glib::SignalProxy< void > | signal_style_updated ()
Glib::SignalProxy< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy< void, bool > | signal_grab_notify ()
Glib::SignalProxy< void, GParamSpec * > | signal_child_notify ()
Glib::SignalProxyDetailedAnyType< void, GParamSpec * > | signal_child_notify (const Glib::ustring & child_property_name)
Glib::SignalProxy< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy< void > | signal_grab_focus ()
Glib::SignalProxy< bool, DirectionType > | signal_focus ()
Glib::SignalProxy< bool, GdkEvent * > | signal_event ()
Glib::SignalProxy< void, GdkEvent * > | signal_event_after ()
Glib::SignalProxy< bool, GdkEventButton * > | signal_button_press_event ()
| Event triggered by user pressing button.
Glib::SignalProxy< bool, GdkEventButton * > | signal_button_release_event ()
| Event triggered by user releasing button.
Glib::SignalProxy< bool, GdkEventScroll * > | signal_scroll_event ()
Glib::SignalProxy< bool, GdkEventMotion * > | signal_motion_notify_event ()
| Event triggered by user moving pointer.
Glib::SignalProxy< bool, GdkEventAny * > | signal_delete_event ()
Glib::SignalProxy< bool, const ::Cairo::RefPtr< ::Cairo::Context > & > | signal_draw ()
Glib::SignalProxy< bool, GdkEventKey * > | signal_key_press_event ()
| Event triggered by a key press will widget has focus.
Glib::SignalProxy< bool, GdkEventKey * > | signal_key_release_event ()
| Event triggered by a key release will widget has focus.
Glib::SignalProxy< bool, GdkEventCrossing * > | signal_enter_notify_event ()
| Event triggered by pointer entering widget area.
Glib::SignalProxy< bool, GdkEventCrossing * > | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area.
Glib::SignalProxy< bool, GdkEventConfigure * > | signal_configure_event ()
| Event triggered by a window resizing.
Glib::SignalProxy< bool, GdkEventFocus * > | signal_focus_in_event ()
Glib::SignalProxy< bool, GdkEventFocus * > | signal_focus_out_event ()
Glib::SignalProxy< bool, GdkEventAny * > | signal_map_event ()
Glib::SignalProxy< bool, GdkEventAny * > | signal_unmap_event ()
Glib::SignalProxy< bool, GdkEventProperty * > | signal_property_notify_event ()
Glib::SignalProxy< bool, GdkEventSelection * > | signal_selection_clear_event ()
Glib::SignalProxy< bool, GdkEventSelection * > | signal_selection_request_event ()
Glib::SignalProxy< bool, GdkEventSelection * > | signal_selection_notify_event ()
Glib::SignalProxy< bool, GdkEventProximity * > | signal_proximity_in_event ()
Glib::SignalProxy< bool, GdkEventProximity * > | signal_proximity_out_event ()
Glib::SignalProxy< bool, GdkEventVisibility * > | signal_visibility_notify_event ()
Glib::SignalProxy< bool, GdkEventWindowState * > | signal_window_state_event ()
Glib::SignalProxy< void, SelectionData &, guint, guint > | signal_selection_get ()
Glib::SignalProxy< void, const SelectionData &, guint > | signal_selection_received ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext > & > | signal_drag_begin ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext > & > | signal_drag_end ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext > &, SelectionData &, guint, guint > | signal_drag_data_get ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext > & > | signal_drag_data_delete ()
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext > &, DragResult > | signal_drag_failed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext > &, guint > | signal_drag_leave ()
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext > &, int, int, guint > | signal_drag_motion ()
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext > &, int, int, guint > | signal_drag_drop ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext > &, int, int, const SelectionData &, guint, guint > | signal_drag_data_received ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::Screen > & > | signal_screen_changed ()
Glib::SignalProxy< void > | signal_composited_changed ()
Glib::SignalProxy< bool > | signal_popup_menu ()
Glib::SignalProxy< bool, int, int, bool, const Glib::RefPtr< Tooltip > & > | signal_query_tooltip ()
Glib::SignalProxy< bool, GdkEventGrabBroken * > | signal_grab_broken_event ()
Glib::SignalProxy< bool, GdkEventExpose * > | signal_damage_event ()
Glib::SignalProxy< bool, GdkEventTouch * > | signal_touch_event ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy< Container * > | property_parent ()
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Container * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget.
Glib::PropertyProxy_ReadOnly< bool > | property_app_paintable () const
| Whether the application will paint directly on the widget.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget can accept the input focus.
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget.
Glib::PropertyProxy_ReadOnly< bool > | property_can_default () const
| Whether the widget can be the default widget.
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| If `true`, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| If `true`, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_composite_child () const
| Whether the widget is part of a composite widget.
Glib::PropertyProxy< Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors, etc).
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors, etc).
Glib::PropertyProxy< Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy_ReadOnly< Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat].
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat].
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized, `nullptr` otherwise.
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether Gtk::Widget::show_all() should not affect this widget.
Glib::PropertyProxy_ReadOnly< bool > | property_no_show_all () const
| Whether Gtk::Widget::show_all() should not affect this widget.
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether the widget is double buffered.
Glib::PropertyProxy_ReadOnly< bool > | property_double_buffered () const
| Whether the widget is double buffered.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space, see Gtk::Align.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space, see Gtk::Align.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space, see Gtk::Align.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space, see Gtk::Align.
Glib::PropertyProxy< int > | property_margin_left ()
| Margin on left side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_left () const
| Margin on left side of widget.
Glib::PropertyProxy< int > | property_margin_right ()
| Margin on right side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_right () const
| Margin on right side of widget.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< int > | property_margin ()
| Sets all four sides' margin at once.
Glib::PropertyProxy_ReadOnly< int > | property_margin () const
| Sets all four sides' margin at once.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the Gtk::Widget::property_hexpand() property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the Gtk::Widget::property_hexpand() property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the Gtk::Widget::property_vexpand() property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the Gtk::Widget::property_vexpand() property.
Glib::PropertyProxy< bool > | property_expand ()
| Whether to expand in both directions.
Glib::PropertyProxy_ReadOnly< bool > | property_expand () const
| Whether to expand in both directions.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
void | set_name (const Glib::ustring & name)
| Sets the name of the buildable object.
Glib::ustring | get_name () const
| Gets the name of the buildable object.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Atk::Implementor
| Implementor (Implementor &&src) noexcept
Implementor & | operator= (Implementor &&src) noexcept
| ~Implementor () noexcept override
AtkImplementor * | gobj ()
const AtkImplementor * | gobj () const
Glib::RefPtr< Atk::Implementor > | wrap (AtkImplementor *object, bool take_copy=false)

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Misc
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Widget * | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events.
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call.
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child().
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction().
static TextDirection | get_default_direction ()
| Obtains the current default reading direction.
static Widget * | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext > & context)
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Atk::Implementor
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
virtual void | on_populate_popup (Menu * menu)
| This is a default handler for the signal signal_populate_popup().
Protected Member Functions inherited from Gtk::Misc
| Misc ()
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_size_allocate (Allocation & allocation)
| This is a default handler for the signal signal_size_allocate().
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed().
virtual void | on_parent_changed (Widget * previous_parent)
| This is a default handler for the signal signal_parent_changed().
virtual void | on_hierarchy_changed (Widget * previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed().
virtual void | on_style_updated ()
| This is a default handler for the signal signal_style_updated().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify().
virtual void | on_child_notify (GParamSpec * pspec)
| This is a default handler for the signal signal_child_notify().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus().
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus().
virtual bool | on_event (GdkEvent * gdk_event)
| This is a default handler for the signal signal_event().
virtual bool | on_button_press_event (GdkEventButton * button_event)
| This is a default handler for the signal signal_button_press_event().
virtual bool | on_button_release_event (GdkEventButton * release_event)
| This is a default handler for the signal signal_button_release_event().
virtual bool | on_scroll_event (GdkEventScroll * scroll_event)
| This is a default handler for the signal signal_scroll_event().
virtual bool | on_motion_notify_event (GdkEventMotion * motion_event)
| This is a default handler for the signal signal_motion_notify_event().
virtual bool | on_delete_event (GdkEventAny * any_event)
| This is a default handler for the signal signal_delete_event().
virtual bool | on_draw (const ::Cairo::RefPtr< ::Cairo::Context > & cr)
| This is a default handler for the signal signal_draw().
virtual bool | on_key_press_event (GdkEventKey * key_event)
| This is a default handler for the signal signal_key_press_event().
virtual bool | on_key_release_event (GdkEventKey * key_event)
| This is a default handler for the signal signal_key_release_event().
virtual bool | on_enter_notify_event (GdkEventCrossing * crossing_event)
| This is a default handler for the signal signal_enter_notify_event().
virtual bool | on_leave_notify_event (GdkEventCrossing * crossing_event)
| This is a default handler for the signal signal_leave_notify_event().
virtual bool | on_configure_event (GdkEventConfigure * configure_event)
| This is a default handler for the signal signal_configure_event().
virtual bool | on_focus_in_event (GdkEventFocus * focus_event)
| This is a default handler for the signal signal_focus_in_event().
virtual bool | on_focus_out_event (GdkEventFocus * gdk_event)
| This is a default handler for the signal signal_focus_out_event().
virtual bool | on_map_event (GdkEventAny * any_event)
| This is a default handler for the signal signal_map_event().
virtual bool | on_unmap_event (GdkEventAny * any_event)
| This is a default handler for the signal signal_unmap_event().
virtual bool | on_property_notify_event (GdkEventProperty * property_event)
| This is a default handler for the signal signal_property_notify_event().
virtual bool | on_selection_clear_event (GdkEventSelection * selection_event)
| This is a default handler for the signal signal_selection_clear_event().
virtual bool | on_selection_request_event (GdkEventSelection * selection_event)
| This is a default handler for the signal signal_selection_request_event().
virtual bool | on_selection_notify_event (GdkEventSelection * selection_event)
| This is a default handler for the signal signal_selection_notify_event().
virtual bool | on_proximity_in_event (GdkEventProximity * proximity_event)
| This is a default handler for the signal signal_proximity_in_event().
virtual bool | on_proximity_out_event (GdkEventProximity * proximity_event)
| This is a default handler for the signal signal_proximity_out_event().
virtual bool | on_visibility_notify_event (GdkEventVisibility * visibility_event)
| This is a default handler for the signal signal_visibility_notify_event().
virtual bool | on_window_state_event (GdkEventWindowState * window_state_event)
| This is a default handler for the signal signal_window_state_event().
virtual void | on_selection_get (SelectionData & selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get().
virtual void | on_selection_received (const SelectionData & selection_data, guint time)
| This is a default handler for the signal signal_selection_received().
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext > & context)
| This is a default handler for the signal signal_drag_begin().
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext > & context)
| This is a default handler for the signal signal_drag_end().
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext > & context, SelectionData & selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get().
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext > & context)
| This is a default handler for the signal signal_drag_data_delete().
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext > & context, guint time)
| This is a default handler for the signal signal_drag_leave().
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext > & context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion().
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext > & context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop().
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext > & context, int x, int y, const SelectionData & selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received().
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen > & previous_screen)
| This is a default handler for the signal signal_screen_changed().
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec ** p2)
virtual void | show_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (int & minimum_width, int & natural_width) const
virtual void | get_preferred_height_for_width_vfunc (int width, int & minimum_height, int & natural_height) const
virtual void | get_preferred_height_vfunc (int & minimum_height, int & natural_height) const
virtual void | get_preferred_width_for_height_vfunc (int height, int & minimum_width, int & natural_width) const
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget.
void | unrealize ()
| This function is only useful in widget implementations.
void | draw (const ::Cairo::RefPtr< ::Cairo::Context > & cr)
| Draws widget to cr.
void | set_mapped (bool mapped=true)
| Marks the widget as being mapped.
void | set_realized (bool realized=true)
| Marks the widget as being realized.
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own.
void | set_window (const Glib::RefPtr< Gdk::Window > & window)
| Sets a widget's window.
void | transform_cairo_context_to_window (const ::Cairo::RefPtr< ::Cairo::Context > & cr, const Glib::RefPtr< const Gdk::Window > & window)
| Transforms the given cairo context cr from widget-relative coordinates to window-relative coordinates.
Requisition | get_requisition () const
| Retrieves the widget's requisition.
void | get_style_property_value (const Glib::ustring & the_property_name, Glib::ValueBase & value) const
| Gets the value of a style property of widget.
void | realize_if_needed ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Atk::Implementor
| Implementor ()
virtual Glib::RefPtr< Object > | ref_accessibile_vfunc ()

## Related Symbols
(Note that these are not member symbols.)
Gtk::Label * | wrap (GtkLabel * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Misc
Gtk::Misc * | wrap (GtkMisc * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gtk::Widget
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock > &)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Static Protected Member Functions inherited from Gtk::Widget
static bool | should_draw_window (const ::Cairo::RefPtr< const ::Cairo::Context > & cr, const Glib::RefPtr< const Gdk::Window > & window)
| This function is supposed to be called in Gtk::Widget::signal_draw() implementations for widgets that support multiple windows.

## Detailed Description

A widget that displays a small to medium amount of text.

A simple setable widget for holding a Glib::ustring.

Key values are the codes which are sent whenever a key is pressed or released. The complete list of key values can be found in the gdk/gdkkeysyms.h header file. They are prefixed with `GDK_KEY_`.

The Label widget looks like this:

## Constructor & Destructor Documentation

## ◆ Label() [1/6]

Gtk::Label::Label | ( | Label && | src | ) |
| noexcept

## ◆ Label() [2/6]

Gtk::Label::Label | ( | const Label & |  | ) |
| delete

## ◆ ~Label()

Gtk::Label::~Label | ( |  | ) |
| overridenoexcept

## ◆ Label() [3/6]

Gtk::Label::Label | ( |  | ) |

## ◆ Label() [4/6]

Gtk::Label::Label | ( | const Glib::ustring & | label,
|  | bool | mnemonic = `false`
| ) |  |
| explicit

## ◆ Label() [5/6]

Gtk::Label::Label | ( | const Glib::ustring & | label,
|  | float | xalign,
|  | float | yalign,
|  | bool | mnemonic = `false`
| ) |  |

This constructor is a shortcut for often used code when you want to create a label with alignment different than default one.

Gtk::Label label(text, x, y, mnemonic);
Gtk::Label
A widget that displays a small to medium amount of text.
Definition label.h:63

is equivalent to:

Gtk::Label label(text, mnemonic);
label.set_alignment(x, y);

Deprecated:
  Use another constructor.

## ◆ Label() [6/6]

Gtk::Label::Label | ( | const Glib::ustring & | label,
|  | Align | halign,
|  | Align | valign = `ALIGN_CENTER`,
|  | bool | mnemonic = `false`
| ) |  |

This constructor is a shortcut to create a Label with Widget alignment properties different from the default ALIGN_FILL.

Gtk::Label label(text, h, v, mnemonic);

is equivalent to:

Gtk::Label label(text, mnemonic);
label.set_halign(h);
label.set_valign(v);

## Member Function Documentation

## ◆ get_angle()

double Gtk::Label::get_angle | ( |  | ) | const

Gets the angle of rotation for the label.

See set_angle().

Since gtkmm 2.6:

Returns
  The angle of rotation for the label.

## ◆ get_attributes()

Pango::AttrList Gtk::Label::get_attributes | ( |  | ) | const

Gets the attribute list that was set on the label using set_attributes(), if any.

This function does not reflect attributes that come from the labels markup (see set_markup()). If you want to get the effective attributes for the label, use pango_layout_get_attribute (gtk_label_get_layout (label)).

Returns
  The attribute list, or `nullptr` if none was set.

## ◆ get_current_uri()

Glib::ustring Gtk::Label::get_current_uri | ( |  | ) | const

Returns the URI for the currently active link in the label.

The active link is the one under the mouse pointer or, in a selectable label, the link in which the text cursor is currently positioned.

This function is intended for use in a Gtk::Label::signal_activate_link() handler or for use in a Gtk::Widget::signal_query_tooltip() handler.

Since gtkmm 2.18:

Returns
  The currently active URI. The string is owned by GTK+ and must not be freed or modified.

## ◆ get_ellipsize()

Pango::EllipsizeMode Gtk::Label::get_ellipsize | ( |  | ) | const

Returns the ellipsizing position of the label.

See set_ellipsize().

Since gtkmm 2.6:

Returns
  Pango::EllipsizeMode.

## ◆ get_justify()

Justification Gtk::Label::get_justify | ( |  | ) | const

Returns the justification of the label.

See set_justify().

Returns
  Gtk::Justification.

## ◆ get_label()

Glib::ustring Gtk::Label::get_label | ( |  | ) | const

Fetches the text from a label widget including any embedded underlines indicating mnemonics and Pango markup.

(See get_text()).

Returns
  The text of the label widget.

## ◆ get_layout() [1/2]

Glib::RefPtr< Pango::Layout > Gtk::Label::get_layout | ( |  | ) |

Gets the Pango::Layout used to display the label.

The layout is useful to e.g. convert text positions to pixel positions, in combination with get_layout_offsets().

Returns
  The Pango::Layout for this label.

## ◆ get_layout() [2/2]

Glib::RefPtr< const Pango::Layout > Gtk::Label::get_layout | ( |  | ) | const

Gets the Pango::Layout used to display the label.

The layout is useful to e.g. convert text positions to pixel positions, in combination with get_layout_offsets().

Returns
  The Pango::Layout for this label.

## ◆ get_layout_offsets()

void Gtk::Label::get_layout_offsets | ( | int & | x,
|  | int & | y
| ) |  | const

Obtains the coordinates where the label will draw the Pango::Layout representing the text in the label; useful to convert mouse events into coordinates inside the Pango::Layout, e.g. to take some action if some part of the label is clicked.

Of course you will need to create a Gtk::EventBox to receive the events, and pack the label inside it, since labels are windowless (they return `false` from Gtk::Widget::get_has_window()). Remember when using the Pango::Layout functions you need to convert to and from pixels using PANGO_PIXELS() or Pango::SCALE.

Parameters

  x | Location to store X offset of layout, or `nullptr`.
  y | Location to store Y offset of layout, or `nullptr`.

## ◆ get_line_wrap()

bool Gtk::Label::get_line_wrap | ( |  | ) | const

Returns whether lines in the label are automatically wrapped.

See set_line_wrap().

Returns
  `true` if the lines of the label are automatically wrapped.

## ◆ get_line_wrap_mode()

Pango::WrapMode Gtk::Label::get_line_wrap_mode | ( |  | ) | const

Returns line wrap mode used by the label.

See set_line_wrap_mode().

Since gtkmm 2.10:

Returns
  `true` if the lines of the label are automatically wrapped.

## ◆ get_lines()

int Gtk::Label::get_lines | ( |  | ) | const

Gets the number of lines to which an ellipsized, wrapping label should be limited.

See set_lines().

Since gtkmm 3.10:

Returns
  The number of lines.

## ◆ get_max_width_chars()

int Gtk::Label::get_max_width_chars | ( |  | ) | const

Retrieves the desired maximum width of label, in characters.

See set_width_chars().

Since gtkmm 2.6:

Returns
  The maximum width of the label in characters.

## ◆ get_mnemonic_keyval()

guint Gtk::Label::get_mnemonic_keyval | ( |  | ) | const

If the label has been set so that it has an mnemonic key this function returns the keyval used for the mnemonic accelerator.

If there is no mnemonic set up it returns #GDK_KEY_VoidSymbol.

Returns
  GDK keyval usable for accelerators, or #GDK_KEY_VoidSymbol.

## ◆ get_mnemonic_widget() [1/2]

Widget * Gtk::Label::get_mnemonic_widget | ( |  | ) |

Retrieves the target of the mnemonic (keyboard shortcut) of this label.

See set_mnemonic_widget().

Returns
  The target of the label’s mnemonic, or `nullptr` if none has been set and the default algorithm will be used.

## ◆ get_mnemonic_widget() [2/2]

const Widget * Gtk::Label::get_mnemonic_widget | ( |  | ) | const

Retrieves the target of the mnemonic (keyboard shortcut) of this label.

See set_mnemonic_widget().

Returns
  The target of the label’s mnemonic, or `nullptr` if none has been set and the default algorithm will be used.

## ◆ get_selectable()

bool Gtk::Label::get_selectable | ( |  | ) | const

Gets the value set by set_selectable().

Returns
  `true` if the user can copy text from the label.

## ◆ get_selection_bounds()

bool Gtk::Label::get_selection_bounds | ( | int & | start,
|  | int & | end
| ) |  | const

Gets the selected range of characters in the label, returning `true` if there’s a selection.

Parameters

  start | Return location for start of selection, as a character offset.
  end | Return location for end of selection, as a character offset.

Returns
  `true` if selection is non-empty.

## ◆ get_single_line_mode()

bool Gtk::Label::get_single_line_mode | ( |  | ) | const

Returns whether the label is in single line mode.

Since gtkmm 2.6:

Returns
  `true` when the label is in single line mode.

## ◆ get_text()

Glib::ustring Gtk::Label::get_text | ( |  | ) | const

Fetches the text from a label widget, as displayed on the screen.

This does not include any embedded underlines indicating mnemonics or Pango markup. (See get_label())

Returns
  The text in the label widget.

## ◆ get_track_visited_links()

bool Gtk::Label::get_track_visited_links | ( |  | ) | const

Returns whether the label is currently keeping track of clicked links.

Since gtkmm 2.18:

Returns
  `true` if clicked links are remembered.

## ◆ get_type()

static GType Gtk::Label::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_use_markup()

bool Gtk::Label::get_use_markup | ( |  | ) | const

Returns whether the label’s text is interpreted as marked up with the [Pango text markup language][PangoMarkupFormat].

See set_use_markup().

Returns
  `true` if the label’s text will be parsed for markup.

## ◆ get_use_underline()

bool Gtk::Label::get_use_underline | ( |  | ) | const

Returns whether an embedded underline in the label indicates a mnemonic.

See set_use_underline().

Returns
  `true` whether an embedded underline in the label indicates the mnemonic accelerator keys.

## ◆ get_width_chars()

int Gtk::Label::get_width_chars | ( |  | ) | const

Retrieves the desired width of label, in characters.

See set_width_chars().

Since gtkmm 2.6:

Returns
  The width of the label in characters.

## ◆ get_xalign()

float Gtk::Label::get_xalign | ( |  | ) | const

Gets the Gtk::Label::property_xalign() property for label.

Since gtkmm 3.16:

Returns
  The xalign property.

## ◆ get_yalign()

float Gtk::Label::get_yalign | ( |  | ) | const

Gets the Gtk::Label::property_yalign() property for label.

Since gtkmm 3.16:

Returns
  The yalign property.

## ◆ gobj() [1/2]

GtkLabel * Gtk::Label::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkLabel * Gtk::Label::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ on_populate_popup()

virtual void Gtk::Label::on_populate_popup | ( | Menu * | menu | ) |
| protectedvirtual

This is a default handler for the signal signal_populate_popup().

## ◆ operator=() [1/2]

Label & Gtk::Label::operator= | ( | const Label & |  | ) |
| delete

## ◆ operator=() [2/2]

Label & Gtk::Label::operator= | ( | Label && | src | ) |
| noexcept

## ◆ property_angle() [1/2]

Glib::PropertyProxy< double > Gtk::Label::property_angle | ( |  | ) |

The angle that the baseline of the label makes with the horizontal, in degrees, measured counterclockwise.

An angle of 90 reads from from bottom to top, an angle of 270, from top to bottom. Ignored if the label is selectable.

Since gtkmm 2.6:

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_angle() [2/2]

Glib::PropertyProxy_ReadOnly< double > Gtk::Label::property_angle | ( |  | ) | const

The angle that the baseline of the label makes with the horizontal, in degrees, measured counterclockwise.

An angle of 90 reads from from bottom to top, an angle of 270, from top to bottom. Ignored if the label is selectable.

Since gtkmm 2.6:

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_attributes() [1/2]

Glib::PropertyProxy< Pango::AttrList > Gtk::Label::property_attributes | ( |  | ) |

A list of style attributes to apply to the text of the label.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_attributes() [2/2]

Glib::PropertyProxy_ReadOnly< Pango::AttrList > Gtk::Label::property_attributes | ( |  | ) | const

A list of style attributes to apply to the text of the label.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_cursor_position()

Glib::PropertyProxy_ReadOnly< int > Gtk::Label::property_cursor_position | ( |  | ) | const

The current position of the insertion cursor in chars.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_ellipsize() [1/2]

Glib::PropertyProxy< Pango::EllipsizeMode > Gtk::Label::property_ellipsize | ( |  | ) |

The preferred place to ellipsize the string, if the label does not have enough room to display the entire string, specified as a Pango::EllipsizeMode.

Note that setting this property to a value other than Pango::ELLIPSIZE_NONE has the side-effect that the label requests only enough space to display the ellipsis "...". In particular, this means that ellipsizing labels do not work well in notebook tabs, unless the Gtk::Notebook tab-expand child property is set to `true`. Other ways to set a label's width are Gtk::Widget::set_size_request() and Gtk::Label::set_width_chars().

Since gtkmm 2.6:

Default value: Pango::ELLIPSIZE_NONE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_ellipsize() [2/2]

Glib::PropertyProxy_ReadOnly< Pango::EllipsizeMode > Gtk::Label::property_ellipsize | ( |  | ) | const

The preferred place to ellipsize the string, if the label does not have enough room to display the entire string, specified as a Pango::EllipsizeMode.

Note that setting this property to a value other than Pango::ELLIPSIZE_NONE has the side-effect that the label requests only enough space to display the ellipsis "...". In particular, this means that ellipsizing labels do not work well in notebook tabs, unless the Gtk::Notebook tab-expand child property is set to `true`. Other ways to set a label's width are Gtk::Widget::set_size_request() and Gtk::Label::set_width_chars().

Since gtkmm 2.6:

Default value: Pango::ELLIPSIZE_NONE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_justify() [1/2]

Glib::PropertyProxy< Justification > Gtk::Label::property_justify | ( |  | ) |

The alignment of the lines in the text of the label relative to each other.

This does NOT affect the alignment of the label within its allocation. See GtkLabel:xalign for that.

Default value: Gtk::JUSTIFY_LEFT

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_justify() [2/2]

Glib::PropertyProxy_ReadOnly< Justification > Gtk::Label::property_justify | ( |  | ) | const

The alignment of the lines in the text of the label relative to each other.

This does NOT affect the alignment of the label within its allocation. See GtkLabel:xalign for that.

Default value: Gtk::JUSTIFY_LEFT

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_label() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::Label::property_label | ( |  | ) |

The contents of the label.

If the string contains [Pango XML markup][PangoMarkupFormat], you will have to set the Gtk::Label::property_use_markup() property to `true` in order for the label to display the markup attributes. See also Gtk::Label::set_markup() for a convenience function that sets both this property and the Gtk::Label::property_use_markup() property at the same time.

If the string contains underlines acting as mnemonics, you will have to set the Gtk::Label::property_use_underline() property to `true` in order for the label to display them.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_label() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Label::property_label | ( |  | ) | const

The contents of the label.

If the string contains [Pango XML markup][PangoMarkupFormat], you will have to set the Gtk::Label::property_use_markup() property to `true` in order for the label to display the markup attributes. See also Gtk::Label::set_markup() for a convenience function that sets both this property and the Gtk::Label::property_use_markup() property at the same time.

If the string contains underlines acting as mnemonics, you will have to set the Gtk::Label::property_use_underline() property to `true` in order for the label to display them.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_lines() [1/2]

Glib::PropertyProxy< int > Gtk::Label::property_lines | ( |  | ) |

The number of lines to which an ellipsized, wrapping label should be limited.

This property has no effect if the label is not wrapping or ellipsized. Set this property to -1 if you don't want to limit the number of lines.

Since gtkmm 3.10:

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_lines() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Label::property_lines | ( |  | ) | const

The number of lines to which an ellipsized, wrapping label should be limited.

This property has no effect if the label is not wrapping or ellipsized. Set this property to -1 if you don't want to limit the number of lines.

Since gtkmm 3.10:

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_width_chars() [1/2]

Glib::PropertyProxy< int > Gtk::Label::property_max_width_chars | ( |  | ) |

The desired maximum width of the label, in characters.

If this property is set to -1, the width will be calculated automatically.

See the section on [text layout][label-text-layout] for details of how Gtk::Label::property_width_chars() and Gtk::Label::property_max_width_chars() determine the width of ellipsized and wrapped labels.

Since gtkmm 2.6:

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_max_width_chars() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Label::property_max_width_chars | ( |  | ) | const

The desired maximum width of the label, in characters.

If this property is set to -1, the width will be calculated automatically.

See the section on [text layout][label-text-layout] for details of how Gtk::Label::property_width_chars() and Gtk::Label::property_max_width_chars() determine the width of ellipsized and wrapped labels.

Since gtkmm 2.6:

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_mnemonic_keyval()

Glib::PropertyProxy_ReadOnly< guint > Gtk::Label::property_mnemonic_keyval | ( |  | ) | const

The mnemonic accelerator key for this label.

Default value: 16777215

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_mnemonic_widget() [1/2]

Glib::PropertyProxy< Widget * > Gtk::Label::property_mnemonic_widget | ( |  | ) |

The widget to be activated when the label's mnemonic key is pressed.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_mnemonic_widget() [2/2]

Glib::PropertyProxy_ReadOnly< Widget * > Gtk::Label::property_mnemonic_widget | ( |  | ) | const

The widget to be activated when the label's mnemonic key is pressed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pattern()

Glib::PropertyProxy_WriteOnly< Glib::ustring > Gtk::Label::property_pattern | ( |  | ) |

A string with _ characters in positions correspond to characters in the text to underline.

Default value: ""

Returns
  A PropertyProxy_WriteOnly that allows you to set the value of the property, or receive notification when the value of the property changes.

## ◆ property_selectable() [1/2]

Glib::PropertyProxy< bool > Gtk::Label::property_selectable | ( |  | ) |

Whether the label text can be selected with the mouse.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_selectable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Label::property_selectable | ( |  | ) | const

Whether the label text can be selected with the mouse.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_selection_bound()

Glib::PropertyProxy_ReadOnly< int > Gtk::Label::property_selection_bound | ( |  | ) | const

The position of the opposite end of the selection from the cursor in chars.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_single_line_mode() [1/2]

Glib::PropertyProxy< bool > Gtk::Label::property_single_line_mode | ( |  | ) |

Whether the label is in single line mode.

In single line mode, the height of the label does not depend on the actual text, it is always set to ascent + descent of the font. This can be an advantage in situations where resizing the label because of text changes would be distracting, e.g. in a statusbar.

Since gtkmm 2.6:

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_single_line_mode() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Label::property_single_line_mode | ( |  | ) | const

Whether the label is in single line mode.

In single line mode, the height of the label does not depend on the actual text, it is always set to ascent + descent of the font. This can be an advantage in situations where resizing the label because of text changes would be distracting, e.g. in a statusbar.

Since gtkmm 2.6:

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_track_visited_links() [1/2]

Glib::PropertyProxy< bool > Gtk::Label::property_track_visited_links | ( |  | ) |

Set this property to `true` to make the label track which links have been visited.

It will then apply the Gtk::STATE_FLAG_VISITED when rendering this link, in addition to Gtk::STATE_FLAG_LINK.

Since gtkmm 2.18:

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_track_visited_links() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Label::property_track_visited_links | ( |  | ) | const

Set this property to `true` to make the label track which links have been visited.

It will then apply the Gtk::STATE_FLAG_VISITED when rendering this link, in addition to Gtk::STATE_FLAG_LINK.

Since gtkmm 2.18:

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_markup() [1/2]

Glib::PropertyProxy< bool > Gtk::Label::property_use_markup | ( |  | ) |

The text of the label includes XML markup.

See pango_parse_markup().

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_markup() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Label::property_use_markup | ( |  | ) | const

The text of the label includes XML markup.

See pango_parse_markup().

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_underline() [1/2]

Glib::PropertyProxy< bool > Gtk::Label::property_use_underline | ( |  | ) |

If set, an underline in the text indicates the next character should be used for the mnemonic accelerator key.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_use_underline() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Label::property_use_underline | ( |  | ) | const

If set, an underline in the text indicates the next character should be used for the mnemonic accelerator key.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_width_chars() [1/2]

Glib::PropertyProxy< int > Gtk::Label::property_width_chars | ( |  | ) |

The desired width of the label, in characters.

If this property is set to -1, the width will be calculated automatically.

See the section on [text layout][label-text-layout] for details of how Gtk::Label::property_width_chars() and Gtk::Label::property_max_width_chars() determine the width of ellipsized and wrapped labels.

Since gtkmm 2.6:

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_width_chars() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::Label::property_width_chars | ( |  | ) | const

The desired width of the label, in characters.

If this property is set to -1, the width will be calculated automatically.

See the section on [text layout][label-text-layout] for details of how Gtk::Label::property_width_chars() and Gtk::Label::property_max_width_chars() determine the width of ellipsized and wrapped labels.

Since gtkmm 2.6:

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap() [1/2]

Glib::PropertyProxy< bool > Gtk::Label::property_wrap | ( |  | ) |

If set, wrap lines if the text becomes too wide.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::Label::property_wrap | ( |  | ) | const

If set, wrap lines if the text becomes too wide.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap_mode() [1/2]

Glib::PropertyProxy< Pango::WrapMode > Gtk::Label::property_wrap_mode | ( |  | ) |

If line wrapping is on (see the Gtk::Label::property_wrap() property) this controls how the line wrapping is done.

The default is Pango::WRAP_WORD, which means wrap on word boundaries.

Since gtkmm 2.10:

Default value: Pango::WRAP_WORD

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap_mode() [2/2]

Glib::PropertyProxy_ReadOnly< Pango::WrapMode > Gtk::Label::property_wrap_mode | ( |  | ) | const

If line wrapping is on (see the Gtk::Label::property_wrap() property) this controls how the line wrapping is done.

The default is Pango::WRAP_WORD, which means wrap on word boundaries.

Since gtkmm 2.10:

Default value: Pango::WRAP_WORD

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_xalign() [1/2]

Glib::PropertyProxy< float > Gtk::Label::property_xalign | ( |  | ) |

The xalign property determines the horizontal aligment of the label text inside the labels size allocation.

Compare this to Gtk::Widget::property_halign(), which determines how the labels size allocation is positioned in the space available for the label.

Since gtkmm 3.16:

Default value: 0.5

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_xalign() [2/2]

Glib::PropertyProxy_ReadOnly< float > Gtk::Label::property_xalign | ( |  | ) | const

The xalign property determines the horizontal aligment of the label text inside the labels size allocation.

Compare this to Gtk::Widget::property_halign(), which determines how the labels size allocation is positioned in the space available for the label.

Since gtkmm 3.16:

Default value: 0.5

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_yalign() [1/2]

Glib::PropertyProxy< float > Gtk::Label::property_yalign | ( |  | ) |

The yalign property determines the vertical aligment of the label text inside the labels size allocation.

Compare this to Gtk::Widget::property_valign(), which determines how the labels size allocation is positioned in the space available for the label.

Since gtkmm 3.16:

Default value: 0.5

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_yalign() [2/2]

Glib::PropertyProxy_ReadOnly< float > Gtk::Label::property_yalign | ( |  | ) | const

The yalign property determines the vertical aligment of the label text inside the labels size allocation.

Compare this to Gtk::Widget::property_valign(), which determines how the labels size allocation is positioned in the space available for the label.

Since gtkmm 3.16:

Default value: 0.5

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ select_region() [1/2]

void Gtk::Label::select_region | ( | int | start_offset | ) |

Selects a range of characters in the label, from start_offset to the end, if the label is selectable.

See gtk_label_set_selectable(). If the label is not selectable, this function has no effect.

Parameters

  start_offset | Start offset (in characters not bytes)

## ◆ select_region() [2/2]

void Gtk::Label::select_region | ( | int | start_offset,
|  | int | end_offset
| ) |  |

Selects a range of characters in the label, if the label is selectable.

See set_selectable(). If the label is not selectable, this function has no effect. If start_offset or end_offset are -1, then the end of the label will be substituted.

Parameters

  start_offset | Start offset (in characters not bytes).
  end_offset | End offset (in characters not bytes).

## ◆ set_angle()

void Gtk::Label::set_angle | ( | double | angle | ) |

Sets the angle of rotation for the label.

An angle of 90 reads from from bottom to top, an angle of 270, from top to bottom. The angle setting for the label is ignored if the label is selectable, wrapped, or ellipsized.

Since gtkmm 2.6:

Parameters

  angle | The angle that the baseline of the label makes with the horizontal, in degrees, measured counterclockwise.

## ◆ set_attributes()

void Gtk::Label::set_attributes | ( | Pango::AttrList & | attrs | ) |

Sets a Pango::AttrList; the attributes in the list are applied to the label text.

The attributes set with this function will be applied and merged with any other attributes previously effected by way of the Gtk::Label::property_use_underline() or Gtk::Label::property_use_markup() properties. While it is not recommended to mix markup strings with manually set attributes, if you must; know that the attributes will be applied to the label after the markup string is parsed.

Parameters

  attrs | A Pango::AttrList, or `nullptr`.

## ◆ set_ellipsize()

void Gtk::Label::set_ellipsize | ( | Pango::EllipsizeMode | mode | ) |

Sets the mode used to ellipsize (add an ellipsis: "...") to the text if there is not enough space to render the entire string.

Since gtkmm 2.6:

Parameters

  mode | A Pango::EllipsizeMode.

## ◆ set_justify()

void Gtk::Label::set_justify | ( | Justification | jtype | ) |

Sets the alignment of the lines in the text of the label relative to each other.

Gtk::JUSTIFY_LEFT is the default value when the widget is first created with new(). If you instead want to set the alignment of the label as a whole, use Gtk::Widget::set_halign() instead. set_justify() has no effect on labels containing only a single line.

Parameters

  jtype | A Gtk::Justification.

## ◆ set_label()

void Gtk::Label::set_label | ( | const Glib::ustring & | str | ) |

Sets the text of the label.

The label is interpreted as including embedded underlines and/or Pango markup depending on the values of the Gtk::Label::property_use_underline() and Gtk::Label::property_use_markup() properties.

Parameters

  str | The new text to set for the label.

## ◆ set_line_wrap()

void Gtk::Label::set_line_wrap | ( | bool | wrap = `true` | ) |

Toggles line wrapping within the Gtk::Label widget.

`true` makes it break lines if text exceeds the widget’s size. `false` lets the text get cut off by the edge of the widget if it exceeds the widget size.

Note that setting line wrapping to `true` does not make the label wrap at its parent container’s width, because GTK+ widgets conceptually can’t make their requisition depend on the parent container’s size. For a label that wraps at a specific position, set the label’s width using Gtk::Widget::set_size_request().

Parameters

  wrap | The setting.

## ◆ set_line_wrap_mode()

void Gtk::Label::set_line_wrap_mode | ( | Pango::WrapMode | wrap_mode | ) |

If line wrapping is on (see set_line_wrap()) this controls how the line wrapping is done.

The default is Pango::WRAP_WORD which means wrap on word boundaries.

Since gtkmm 2.10:

Parameters

  wrap_mode | The line wrapping mode.

## ◆ set_lines()

void Gtk::Label::set_lines | ( | int | lines | ) |

Sets the number of lines to which an ellipsized, wrapping label should be limited.

This has no effect if the label is not wrapping or ellipsized. Set this to -1 if you don’t want to limit the number of lines.

Since gtkmm 3.10:

Parameters

  lines | The desired number of lines, or -1.

## ◆ set_markup()

void Gtk::Label::set_markup | ( | const Glib::ustring & | str | ) |

Parses str which is marked up with the [Pango text markup language][PangoMarkupFormat], setting the label’s text and attribute list based on the parse results.

If the str is external data, you may need to escape it with Glib::markup_escape_text() or Glib::markup_printf_escaped():

[C example ellipted]

This function will set the Gtk::Label::property_use_markup() property to `true` as a side effect.

If you set the label contents using the Gtk::Label::property_label() property you should also ensure that you set the Gtk::Label::property_use_markup() property accordingly.

See also: set_text()

Parameters

  str | A markup string (see [Pango markup format][PangoMarkupFormat]).

## ◆ set_markup_with_mnemonic()

void Gtk::Label::set_markup_with_mnemonic | ( | const Glib::ustring & | str | ) |

Parses str which is marked up with the [Pango text markup language][PangoMarkupFormat], setting the label’s text and attribute list based on the parse results.

If characters in str are preceded by an underscore, they are underlined indicating that they represent a keyboard accelerator called a mnemonic.

The mnemonic key can be used to activate another widget, chosen automatically, or explicitly using set_mnemonic_widget().

Parameters

  str | A markup string (see [Pango markup format][PangoMarkupFormat]).

## ◆ set_max_width_chars()

void Gtk::Label::set_max_width_chars | ( | int | n_chars | ) |

Sets the desired maximum width in characters of label to n_chars.

Since gtkmm 2.6:

Parameters

  n_chars | The new desired maximum width, in characters.

## ◆ set_mnemonic_widget()

void Gtk::Label::set_mnemonic_widget | ( | Widget & | widget | ) |

If the label has been set so that it has an mnemonic key (using i.e. set_markup_with_mnemonic(), set_text_with_mnemonic(), new_with_mnemonic() or the “use_underline” property) the label can be associated with a widget that is the target of the mnemonic.

When the label is inside a widget (like a Gtk::Button or a Gtk::Notebook tab) it is automatically associated with the correct widget, but sometimes (i.e. when the target is a Gtk::Entry next to the label) you need to set it explicitly using this function.

The target widget will be accelerated by emitting the GtkWidget::mnemonic-activate signal on it. The default handler for this signal will activate the widget if there are no mnemonic collisions and toggle focus between the colliding widgets otherwise.

Parameters

  widget | The target Gtk::Widget, or `nullptr` to unset.

## ◆ set_pattern()

void Gtk::Label::set_pattern | ( | const Glib::ustring & | pattern | ) |

The pattern of underlines you want under the existing text within the Gtk::Label widget.

For example if the current text of the label says “FooBarBaz” passing a pattern of “___ ___” will underline “Foo” and “Baz” but not “Bar”.

Parameters

  pattern | The pattern as described above.

## ◆ set_selectable()

void Gtk::Label::set_selectable | ( | bool | setting = `true` | ) |

Selectable labels allow the user to select text from the label, for copy-and-paste.

Parameters

  setting | `true` to allow selecting text in the label.

## ◆ set_single_line_mode()

void Gtk::Label::set_single_line_mode | ( | bool | single_line_mode = `true` | ) |

Sets whether the label is in single line mode.

Since gtkmm 2.6:

Parameters

  single_line_mode | `true` if the label should be in single line mode.

## ◆ set_text()

void Gtk::Label::set_text | ( | const Glib::ustring & | str | ) |

Doesn't use markup.

## ◆ set_text_with_mnemonic()

void Gtk::Label::set_text_with_mnemonic | ( | const Glib::ustring & | str | ) |

Sets the label’s text from the string str.

If characters in str are preceded by an underscore, they are underlined indicating that they represent a keyboard accelerator called a mnemonic. The mnemonic key can be used to activate another widget, chosen automatically, or explicitly using set_mnemonic_widget().

Parameters

  str | A string.

## ◆ set_track_visited_links()

void Gtk::Label::set_track_visited_links | ( | bool | track_links = `true` | ) |

Sets whether the label should keep track of clicked links (and use a different color for them).

Since gtkmm 2.18:

Parameters

  track_links | `true` to track visited links.

## ◆ set_use_markup()

void Gtk::Label::set_use_markup | ( | bool | setting = `true` | ) |

Sets whether the text of the label contains markup in [Pango’s text markup language][PangoMarkupFormat].

See set_markup().

Parameters

  setting | `true` if the label’s text should be parsed for markup.

## ◆ set_use_underline()

void Gtk::Label::set_use_underline | ( | bool | setting = `true` | ) |

If true, an underline in the text indicates the next character should be used for the mnemonic accelerator key.

Parameters

  setting | `true` if underlines in the text indicate mnemonics.

## ◆ set_width_chars()

void Gtk::Label::set_width_chars | ( | int | n_chars | ) |

Sets the desired width in characters of label to n_chars.

Since gtkmm 2.6:

Parameters

  n_chars | The new desired width, in characters.

## ◆ set_xalign()

void Gtk::Label::set_xalign | ( | float | xalign | ) |

Sets the Gtk::Label::property_xalign() property for label.

Since gtkmm 3.16:

Parameters

  xalign | The new xalign value, between 0 and 1.

## ◆ set_yalign()

void Gtk::Label::set_yalign | ( | float | yalign | ) |

Sets the Gtk::Label::property_yalign() property for label.

Since gtkmm 3.16:

Parameters

  yalign | The new yalign value, between 0 and 1.

## ◆ signal_activate_link()

Glib::SignalProxy< bool, const Glib::ustring & > Gtk::Label::signal_activate_link | ( |  | ) |

Slot Prototype:
  `bool on_my_activate_link(const Glib::ustring& uri)`

Flags: Run Last

The signal which gets emitted to activate a URI. Applications may connect to it to override the default behaviour, which is to call gtk_show_uri_on_window().

Since gtkmm 2.18:

Parameters

  uri | The URI that is activated.

Returns
  `true` if the link has been activated.

## ◆ signal_populate_popup()

Glib::SignalProxy< void, Menu * > Gtk::Label::signal_populate_popup | ( |  | ) |

Slot Prototype:
  `void on_my_populate_popup(Menu* menu)`

Flags: Run Last

The signal_populate_popup() signal gets emitted before showing the context menu of the label. Note that only selectable labels have context menus.

If you need to add items to the context menu, connect to this signal and append your menuitems to the menu.

Parameters

  menu | The menu that is being populated.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::Label * wrap | ( | GtkLabel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.